'Rems' Screen Fader!  A true, and I mean TRUE screen fade.

DEFINT A-Z
DECLARE SUB FadeIn (R%, G%, B%, Frames%)  'Required
DECLARE SUB FadeOut (R%, G%, B%, Frames%) 'Required
DECLARE SUB GetPal ()                     'Required
DIM SHARED Pal(255, 2) AS STRING * 1      'Required

SCREEN 13

GetPal 'Store the palette in PAL, Required before each FadeOut

DO UNTIL INKEY$ <> ""
  LINE (RND * 319, RND * 199)-(RND * 319, RND * 199), RND * 255 'Draw random
LOOP                                                            'lines on the
       'R  G   B  Frames                                        'screen
FadeOut 0, 0, 63, 400    'Fade out in 400 frames, to blue
FadeIn 0, 0, 63, 200     'Fade in in 200 frames, from blue

FadeOut 63, 0, 0, 100
FadeIn 63, 0, 0, 50

FadeOut 0, 63, 0, 25
FadeIn 0, 63, 0, 12

DEFSNG A-Z
SUB FadeIn (R%, G%, B%, Frames%)
  FOR Fade% = Frames% TO 0 STEP -1
    OUT &H3C8, 0
    FOR Count% = 0 TO 255
      IF R% < ASC(Pal(Count%, 0)) THEN
        OUT &H3C9, ASC(Pal(Count%, 0)) - (((ASC(Pal(Count%, 0)) - R%) / Frames%) * Fade%)
      ELSEIF R% > ASC(Pal(Count%, 0)) THEN
        OUT &H3C9, ASC(Pal(Count%, 0)) + (((R% - ASC(Pal(Count%, 0))) / Frames%) * Fade%)
      ELSE
        OUT &H3C9, R%
      END IF
      IF G% < ASC(Pal(Count%, 1)) THEN
        OUT &H3C9, ASC(Pal(Count%, 1)) - (((ASC(Pal(Count%, 1)) - G%) / Frames%) * Fade%)
      ELSEIF G% > ASC(Pal(Count%, 1)) THEN
        OUT &H3C9, ASC(Pal(Count%, 1)) + (((G% - ASC(Pal(Count%, 1))) / Frames%) * Fade%)
      ELSE
        OUT &H3C9, G%
      END IF
      IF B% < ASC(Pal(Count%, 2)) THEN
        OUT &H3C9, ASC(Pal(Count%, 2)) - (((ASC(Pal(Count%, 2)) - B%) / Frames%) * Fade%)
      ELSEIF B% > ASC(Pal(Count%, 2)) THEN
        OUT &H3C9, ASC(Pal(Count%, 2)) + (((B% - ASC(Pal(Count%, 2))) / Frames%) * Fade%)
      ELSE
        OUT &H3C9, B%
      END IF
    NEXT
    WAIT 986, 8
    WAIT 986, 8, 8
  NEXT
  FOR Count% = 0 TO 255
    OUT &H3C8, Count%
    OUT &H3C9, ASC(Pal(Count%, 0))
    OUT &H3C9, ASC(Pal(Count%, 1))
    OUT &H3C9, ASC(Pal(Count%, 2))
  NEXT
  WAIT 986, 8
  WAIT 986, 8, 8
END SUB

SUB FadeOut (R%, G%, B%, Frames%)
  FOR Fade% = 0 TO Frames% STEP 1
    OUT &H3C8, 0
    FOR Count% = 0 TO 255
      IF R% < ASC(Pal(Count%, 0)) THEN
        OUT &H3C9, ASC(Pal(Count%, 0)) - (((ASC(Pal(Count%, 0)) - R%) / Frames%) * Fade%)
      ELSEIF R% > ASC(Pal(Count%, 0)) THEN
        OUT &H3C9, ASC(Pal(Count%, 0)) + (((R% - ASC(Pal(Count%, 0))) / Frames%) * Fade%)
      ELSE
        OUT &H3C9, R%
      END IF
      IF G% < ASC(Pal(Count%, 1)) THEN
        OUT &H3C9, ASC(Pal(Count%, 1)) - (((ASC(Pal(Count%, 1)) - G%) / Frames%) * Fade%)
      ELSEIF G% > ASC(Pal(Count%, 1)) THEN
        OUT &H3C9, ASC(Pal(Count%, 1)) + (((G% - ASC(Pal(Count%, 1))) / Frames%) * Fade%)
      ELSE
        OUT &H3C9, G%
      END IF
      IF B% < ASC(Pal(Count%, 2)) THEN
        OUT &H3C9, ASC(Pal(Count%, 2)) - (((ASC(Pal(Count%, 2)) - B%) / Frames%) * Fade%)
      ELSEIF B% > ASC(Pal(Count%, 2)) THEN
        OUT &H3C9, ASC(Pal(Count%, 2)) + (((B% - ASC(Pal(Count%, 2))) / Frames%) * Fade%)
      ELSE
        OUT &H3C9, B%
      END IF
    NEXT
    WAIT 986, 8
    WAIT 986, 8, 8
  NEXT
  FOR Count% = 0 TO 255
    OUT &H3C8, Count%
    OUT &H3C9, R%
    OUT &H3C9, G%
    OUT &H3C9, B%
  NEXT
  WAIT 986, 8
  WAIT 986, 8, 8
END SUB

SUB GetPal
  OUT &H3C7, 0
  FOR Count% = 0 TO 255
    Pal(Count%, 0) = CHR$(INP(&H3C9))
    Pal(Count%, 1) = CHR$(INP(&H3C9))
    Pal(Count%, 2) = CHR$(INP(&H3C9))
  NEXT
END SUB

